<?php

/**
 * Pony.fm - A community for pony fan music.
 * Copyright (C) 2015 Feld0.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

namespace Database\Seeders;

use Illuminate\Database\Seeder;
use Illuminate\Support\Facades\DB;

class ShowSongTableSeeder extends Seeder
{
    private $showSongs = [
        [
            'title' => 'My Little Pony Theme Song',
            'slug' => 'my-little-pony-theme-song',
            'lyrics' => "[Backup singer]
My Little Pony, My Little Pony
Ahh, ahh, ahh, ahhh...

[Twilight Sparkle]
(My Little Pony)
I used to wonder what friendship could be
(My Little Pony)
Until you all shared its magic with me

[Rainbow Dash]
Big adventure

[Pinkie Pie]
Tons of fun

[Rarity]
A beautiful heart

[Applejack]
Faithful and strong

[Fluttershy]
Sharing kindness

[Twilight Sparkle]
It's an easy feat
And magic makes it all complete
You have my little ponies
Do you know you're all my very best friends?",

        ],
        [
            'title' => 'Laughter Song (Giggle at the Ghostly)',
            'slug' => 'laughter-song',
            'lyrics' => "[Pinkie Pie]
When I was a little filly and the sun was going down...

Twilight Sparkle: Tell me she's not...

[Pinkie Pie]
The darkness and the shadows, they would always make me frown

Rarity: She is.

[Pinkie Pie]
I'd hide under my pillow
From what I thought I saw
But Granny Pie said that wasn't the way
To deal with fears at all

Rainbow Dash: Then what is?

[Pinkie Pie]
She said: \"Pinkie, you gotta stand up tall
Learn to face your fears
You'll see that they can't hurt you
Just laugh to make them disappear.\"

Ha! Ha! Ha!

Ponies: [gasp]

[Pinkie Pie]
So, giggle at the ghostly
Guffaw at the grossly
Crack up at the creepy
Whoop it up with the weepy
Chortle at the kooky
Snortle at the spooky

And tell that big dumb scary face to take a hike and leave you alone and if he thinks he can scare you then he's got another thing coming and the very idea of such a thing just makes you wanna... hahahaha... heh...

Laaaaaaauuugh!",

        ],
        [
            'title' => 'Winter Wrap-Up',
            'slug' => 'winter-wrap-up',
            'lyrics' => "[Rainbow Dash]
Three months of winter coolness
And awesome holidays

[Pinkie Pie]
We've kept our hoovsies warm at home
Time off from work to play

[Applejack]
But the food we've stored is runnin' out
And we can't grow in this cold

[Rarity]
And even though I love my boots
This fashion's getting old

[Twilight Sparkle]
The time has come to welcome spring
And all things warm and green
But it's also time to say goodbye
It's winter we must clean
How can I help? I'm new, you see
What does everypony do?
How do I fit in without magic?
I haven't got a clue!

[Choir]
Winter Wrap Up! Winter Wrap Up!
Let's finish our holiday cheer
Winter Wrap Up! Winter Wrap Up!

[Applejack]
'Cause tomorrow springâ€“

[Rainbow Dash]
â€“is here!

[Choir]
'Cause tomorrow spring is here!

[Rainbow Dash]
Bringing home the southern birds
A Pegasus' job begins
And clearing all the gloomy skies
To let the sunshine in
We move the clouds
And we melt the white snow

[Rainbow Dash and Pinkie Pie]
When the sun comes up
Its warmth and beauty will glow!

[Choir]
Winter Wrap Up! Winter Wrap Up!
Let's finish our holiday cheer
Winter Wrap Up! Winter Wrap Up!
'Cause tomorrow spring is here
Winter Wrap Up! Winter Wrap Up!
'Cause tomorrow spring is here
'Cause tomorrow spring is here!

[Rarity]
Little critters hibernate
Under the snow and ice

[Fluttershy]
We wake up all their sleepy heads
So quietly and nice

[Rarity]
We help them gather up their food
Fix their homes below

[Fluttershy]
We welcome back the southern birds

[Fluttershy and Rarity]
So their families can grow!

[Choir]
Winter Wrap Up! Winter Wrap Up! ([Rarity] Winter, winter)
Let's finish our holiday cheer
Winter Wrap Up! Winter Wrap Up! ([Rarity] Winter, winter)
'Cause tomorrow spring is here
Winter Wrap Up! Winter Wrap Up! ([Rarity] Winter, winter)
'Cause tomorrow spring is here
'Cause tomorrow spring is here!

[Applejack]
No easy task to clear the ground
Plant our tiny seeds
With proper care and sunshine
Everyone it feeds
Apples, carrots, celery stalks
Colorful flowers too
We must work so very hard

[Applejack, Cherry Berry, and Golden Harvest]
It's just so much to do!

[Choir]
Winter Wrap Up! Winter Wrap Up!
Let's finish our holiday cheer
Winter Wrap Up! Winter Wrap Up!
'Cause tomorrow spring is here
Winter Wrap Up! Winter Wrap Up!

[Pinkie Pie]
'Cause tomorrow spring is here

[Choir]
'Cause tomorrow spring is here!

[Twilight Sparkle]
Now that I know what they all do
I have to find my place
And help with all of my heart
Tough task ahead I face
How will I do without my magic
Help the Earth pony way
I wanna belong so I must
Do my best today,
Do my best today!

[Choir]
Winter Wrap Up! Winter Wrap Up!
Let's finish our holiday cheer
Winter Wrap Up! Winter Wrap Up!
'Cause tomorrow spring is here
Winter Wrap Up! Winter Wrap Up!

[Twilight Sparkle]
'Cause tomorrow spring is here
'Cause tomorrow spring is here
'Cause tomorrow spring is here!",
        ],
        [
            'title' => 'EQG - Helping Twilight Win The Crown',
            'slug' => 'helping-twilight-win-the-crown',
            'lyrics' => "[Pinkie Pie, Rainbow Dash, Applejack, Fluttershy, Rarity]
Hey! Hey! Everybody!
We've got something to say.
We may seem as different,
As the night is from day.
But you look a little deeper,
And you will see:
That I'm just like you
And you're just like me.
Yeah!

Hey! Hey! Everybody!
We're here to shout,
That the magic of friendship
Is what it's all about.
Yeah, we thought we were different,
As the night is from the day.
Until Twilight Sparkle helped us see another way.

So get up, get down.
If you're gonna come around.
We can work together,
Helping Twilight win the crown.
So get up, get down.
'Cause it's gonna make a sound.
If we work together,
Helping Twilight Sparkle win the crown.

[Pinkie Pie]
Hey! Hey! Hands up now!
We're sending a message to the crowd!
Hands wave up, then come down,
We party together all around!

[Rarity]
Generous, honesty.

[Applejack]
Laughter, kindness, loyalty.

[Fluttershy]
Twilight helped us each to see.

[Rainbow Dash]
All that we can be.

[Pinkie Pie, Rainbow Dash, Applejack, Fluttershy, Rarity]
So get up, get down.
If you're gonna come around.
We can work together,
Helping Twilight win the crown.
So get up, get down.
'Cause it's gonna make a sound.
If we work together,
Helping Twilight Sparkle win the crown.

[Twilight Sparkle]
I'm gonna be myself
No matter what I do.
And if we're different, yeah,
I want you to be true to you.
If you follow me,
We'll put our differences aside.
We'll stick together
And start working on that school pride!

[All students]
Jump up, make a sound. Hey!
Stomp your hooves, turn around.
Start now, make a change,
Gonna come around.
Jump up, make a sound. Hey!
Stomp your hooves, turn around.
Canterlot Wondercolts
Help her win the crown.

Jump up, make a sound. Hey!
Stomp your hooves, turn around.
Start now, make a change,
Gonna come around.
Jump up, make a sound. Hey!
Stomp your hooves, turn around.
Canterlot Wondercolts
Help her win the crown.

Jump up, make a sound. Hey!
Stomp your hooves, turn around.
Start now, make a change,
Gonna come around.
Jump up, make a sound. Hey!
Stomp your hooves, turn around.
Canterlot Wondercolts
Help her win the crown...",
        ],
    ];

    /**
     * Run the database seeds.
     *
     * @return void
     */
    public function run()
    {
        // This table only needs to be filled once.
        //
        // Song lyrics used are (C) Hasbro and
        // sourced from http://mlp.wikia.com/wiki/Songs
        if (DB::table('show_songs')->count() === 0) {
            $now = \Carbon\Carbon::now();
            $showSongs = array_map(function (array $item) use ($now) {
                $item['created_at'] = $now;
                $item['updated_at'] = $now;

                return $item;
            }, $this->showSongs);
            DB::table('show_songs')->insert($showSongs);
        }
    }
}
